
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/*  This code generated by: 
 *      Author : thomas
 *      Date   : Mon Sep 26 2003
 */

#include <kdebug.h>
#include "xmlcodecomment.h"

// Constructors/Destructors
//  

XMLCodeComment::XMLCodeComment ( CodeDocument * doc, const QString & text ) 
    : CodeComment (doc, text)
{

}

XMLCodeComment::~XMLCodeComment ( ) { }

//  
// Methods
//  


// Accessor methods
//  

// Other methods
//  

/**
 * Save the XMI representation of this object
 * @return      bool    status of save
 */
bool XMLCodeComment::saveToXMI ( QDomDocument & doc, QDomElement & root ) {
        bool status = true;

        QDomElement blockElement = doc.createElement( "xmlcodecomment" );
        setAttributesOnNode(doc, blockElement); // as we added no additional fields to this class we may
                                                // just use parent TextBlock method
        root.appendChild( blockElement );

        return status;
}

/**
 * load params from the appropriate XMI element node.
 */
void XMLCodeComment::loadFromXMI ( QDomElement & root ) {
        setAttributesFromNode(root);
}

/**
 * @return	QString
 */
QString XMLCodeComment::toString ( ) 
{

	QString output = "";

        // simple output method
        if(getWriteOutText())
        {
		QString indent = getIndentationString();
                QString endLine = getNewLineEndingChars();
		QString body = getText();
                output.append(indent+"<!-- ");
		if(!body.isEmpty())
			output.append(formatMultiLineText (body, indent, endLine));
		output.append(indent+"-->"+endLine);
        }

        return output; 
}


#include "xmlcodecomment.moc"
